#!/usr/bin/perl
#
# Convert an 8-bit sample to something the Direct-Sound driver can use
# (c) 1998 by Markus L. Noga
#
$infile =shift;
$outfile="sample.h" unless $outfile=shift;
$varname="sample" unless $varname=shift;

$scale=3;		# sample scaling factor
$lag=0x0d;		# how much does our engine lag behind?
$lag++;			# B after A!

open(IN ,"<$infile" ) || die;
open(OUT,">$outfile") || die;

printf OUT "//\n// this file was generated Markus L. Noga's sample-convert.pl\n//\n\n";
printf OUT "unsigned char $varname\[]={\n\t";

$charctr=0;

$the_byte=0;
$bitctr=0;
$lastn=256;

while(read IN,$c,1) {

	$n=ord($c);
#	if ($n & 0x80) {
#                $n = 382 - $n;
#        }
#	if($n>$lastn) {
#		$the_byte|=1;
#	}
#	$lastn=$n;
	
	if($n>128) {
		$the_byte|=1;
	}
	
	if((++$bitctr)==8) {
		printf OUT "0x%02x, ",$the_byte;
		if( ($charctr++)==10 ) {
			$charctr=0;
			printf OUT "\n\t";
		}
		$bitctr=0;
		$the_byte=0;
	} else {
		$the_byte<<=1;
	}
	
}

$the_byte<<=8-$bitctr;

printf OUT "0x%02x\n};\n",$the_byte;
close IN;
close OUT;
